<template>
  <span class="role_modal">
    <div class="modal active" id="modal-id">
      <a class="modal-overlay" aria-label="Close"></a>
      <div class="modal-container" id ="modalContainer" >
        <div class="modal-header">
          <div class="heading" v-if="display_add">
            <a v-on:click="closeModal" class="btn btn-clear float-right close-btn" aria-label="Close"></a>
            <div class="modal-title h5">Add Role </div>
            <div class="modal-title p">New User Role</div>
          </div>         
          <div class="heading" v-if="display_edit">
            <a v-on:click="closeModal" class="btn btn-clear float-right close-btn" aria-label="Close"></a>
            <div class="modal-title h5">Edit Role </div>              
          </div>
        </div>
        <div class="modal-body" >
          <div class="modal_content" id="content">
						<!-- content here -->            
            <form id="add-permissions-form" v-if="display_add" > 							
							<div class="columns">
								<div class="column col-4">
									<div>Role</div>			
									<input type="text" class="role-form-input" name="role[name]" v-bind:class="{ active1: roleError}" v-on:keydown= "removeClass_role" >
									<div class="error" v-bind:class="{ display: roleError}"> Cant be blank</div>									
								</div>  
							</div>
							<div class="columns accordion-pane">
								<div class="column col-12">
									<div class="accordion">
										<input type="checkbox" id="accordion-1" name="accordion-checkbox" hidden>
										<label class="accordion-header" for="accordion-1">
											<i class="icon icon-arrow-right mr-1"></i>
											<span class="employee_role_text"><b>Employees</b></span>
										</label>
										<div class="accordion-body ac_body">
										<!-- Accordions content -->          
											<div class="columns show_div3  grey_div">
												<div class="column col-5 show_label permissions_text">Permissions</div>            
											</div>
											<div class="columns show_div3 ">
												<div class="column col-5 show_label">Add Employee</div>
												<div class="column col-4 show_field"><input type="checkbox" name="permissions[]" value="create"></div>
											</div>
											<div class="columns show_div3  grey_div">
												<div class="column col-5 show_label">Bulk Upload Employee</div>
												<div class="column col-4 show_field"><input type="checkbox" name="permissions[]" value="bulk_upload"></div>
											</div>
											<div class="columns show_div3 ">
												<div class="column col-5 show_label">View Details</div>
												<div class="column col-4 show_field"><input type="checkbox" name="role[permissions3]" value="view"></div>
											</div>
											<div class="columns show_div3  grey_div">
												<div class="column col-5 show_label">Edit Details</div>
												<div class="column col-4 show_field"><input type="checkbox" name="role[permissions]" value=""></div>
											</div>
											<div class="columns show_div3 ">
												<div class="column col-5 show_label">Add Account</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value=""></div>
											</div>
											<div class="columns show_div3  grey_div">
												<div class="column col-5 show_label"> Edit Account</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value=""></div>
											</div>
											<div class="columns show_div3 ">
												<div class="column col-5 show_label">View Employee Package</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value=""></div>
											</div>    
											<div class="columns show_div3  grey_div">
												<div class="column col-5 show_label"> Submit Package</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value=""></div>
											</div>
											<div class="columns show_div3 ">
												<div class="column col-5 show_label">Add Earnings</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value=""></div>
											</div>
											<div class="columns show_div3  grey_div">
												<div class="column col-5 show_label">View Earnings</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value=""></div>
											</div>
											<div class="columns show_div3 ">
												<div class="column col-5 show_label">Delete Earnings</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value=""></div>
											</div>  
											<div class="columns show_div3  grey_div">
												<div class="column col-5 show_label"> View Deductions</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value=""></div>
											</div>
											<div class="columns show_div3 ">
												<div class="column col-5 show_label">Add Deductions</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value=""></div>
											</div>
											<div class="columns show_div3  grey_div">
												<div class="column col-5 show_label">Delete Deductions</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value=""></div>
											</div>            
										</div>
									</div>	
									<div class="accordion">
										<input type="checkbox" id="accordion-2" name="accordion-checkbox" hidden>
										<label class="accordion-header" for="accordion-2">
											<i class="icon icon-arrow-right mr-1"></i>
											<span class="employee_role_text"><b>Payroll</b></span>
										</label>
										<div class="accordion-body ac_body">
											<!-- Accordions content -->	
											<div class="columns show_div3  grey_div">
												<div class="column col-5 show_label permissions_text">Permissions</div>            
											</div>
											<div class="columns show_div3 ">
												<div class="column col-5 show_label">Run Payroll</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value=""></div>
											</div>
											<div class="columns show_div3  grey_div">
												<div class="column col-5 show_label">Upload Pay Register</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value=""></div>
											</div>
											<div class="columns show_div3 ">
												<div class="column col-5 show_label">View Payslip</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value=""></div>
											</div>
											<div class="columns show_div3  grey_div">
												<div class="column col-5 show_label">Download Payslip</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value=""></div>
											</div>	
											<div class="columns show_div3 ">
												<div class="column col-5 show_label">Print Payslip</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value=""></div>
											</div>				
										</div>
									</div>
									<div class="accordion">
										<input type="checkbox" id="accordion-3" name="accordion-checkbox" hidden>
										<label class="accordion-header" for="accordion-3">
											<i class="icon icon-arrow-right mr-1"></i>
											<span class="employee_role_text"><b>Approvals</b></span>
										</label>
										<div class="accordion-body ac_body">
											<!-- Accordions content -->				
										</div>
									</div>
									<div class="accordion">
										<input type="checkbox" id="accordion-4" name="accordion-checkbox" hidden>
										<label class="accordion-header" for="accordion-4">
											<i class="icon icon-arrow-right mr-1"></i>
											<span class="employee_role_text"><b>Tasks</b></span>
										</label>
										<div class="accordion-body ac_body">
											<!-- Accordions content -->					
										</div>
									</div>
									<div class="accordion">
										<input type="checkbox" id="accordion-5" name="accordion-checkbox" hidden>
										<label class="accordion-header" for="accordion-5">
											<i class="icon icon-arrow-right mr-1"></i>
											<span class="employee_role_text"><b>Settings</b></span>
										</label>
										<div class="accordion-body ac_body">
											<!-- Accordions content -->	
											<div class="columns show_div3  grey_div">
												<div class="column col-5 show_label permissions_text">Permissions</div>            
											</div>
											<div class="columns show_div3 ">
												<div class="column col-5 show_label">Create Package Template</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value=""></div>
											</div>
											<div class="columns show_div3  grey_div">
												<div class="column col-5 show_label">View Package Template</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value=""></div>
											</div>
											<div class="columns show_div3 ">
											<div class="column col-5 show_label"> Edit Package Template</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value=""></div>
											</div>
											<div class="columns show_div3  grey_div">
												<div class="column col-5 show_label">Delete Package Template</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value=""></div>
											</div>
											<div class="columns show_div3 ">
												<div class="column col-5 show_label">View Roles</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value=""></div>
											</div>
											<div class="columns show_div3  grey_div">
												<div class="column col-5 show_label"> Edit Role Permission</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value=""></div>
											</div>
											<div class="columns show_div3 ">
												<div class="column col-5 show_label">Create Role</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value=""></div>
											</div>         				
										</div>
									</div>

								</div>  
							</div>
							<div class="column col-4 show_field hidden-checkbox"><input type="checkbox" name="permissions[]" value=" " checked></div>
            </form>

						<form id="edit-permissions-form" v-if="display_edit"> 							
							<div class="columns">
								<div class="column col-4">
									<div>Role</div>			
								<select v-model="role" @change="onChange(role)" >
									<option v-for="role in user_roles" :value="role" :key="role.id">{{role.name}}</option>
									<input type="text" v-model="role.id" name="role[id]">
								</select>				
								</div>  
							</div>
							<div class="columns accordion-pane">
								<div class="column col-12">
									<div class="accordion">
										<input type="checkbox" id="accordion-1" name="accordion-checkbox" hidden>
										<label class="accordion-header" for="accordion-1">
											<i class="icon icon-arrow-right mr-1"></i>
											<span class="employee_role_text"><b>Employees</b></span>
										</label>
										<div class="accordion-body ac_body">
										<!-- Accordions content -->          
											<div class="columns show_div3  grey_div">
												<div class="column col-5 show_label permissions_text">Permissions</div>            
											</div>
											<div class="columns show_div3 ">
												<div class="column col-5 show_label">Add Employee</div>
												<div class="column col-4 show_field"><input type="checkbox"  value="Add Account" name="permissions[]" v-model="checkedPermissions" ></div>
											</div>
											<div class="columns show_div3  grey_div">
												<div class="column col-5 show_label">Bulk Upload Employee</div>
												<div class="column col-4 show_field"><input type="checkbox" name="permissions[]" value="bulk" v-model="checkedPermissions"></div>
											</div>
											<div class="columns show_div3 ">
												<div class="column col-5 show_label">View Details</div>
												<div class="column col-4 show_field"><input type="checkbox" name="permissions[]" value="view" v-model="checkedPermissions"></div>
											</div>
											<div class="columns show_div3  grey_div">
												<div class="column col-5 show_label">Edit Details</div>
												<div class="column col-4 show_field"><input type="checkbox" name="permissions[]" value="" v-model="checkedPermissions"></div>
											</div>
											<div class="columns show_div3 ">
												<div class="column col-5 show_label">Add Account</div>
												<div class="column col-4 show_field"><input type="checkbox" name="permissions[]" value="" v-model="checkedPermissions"></div>
											</div>
											<div class="columns show_div3  grey_div">
												<div class="column col-5 show_label"> Edit Account</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value="" v-model="checkedPermissions"></div>
											</div>
											<div class="columns show_div3 ">
												<div class="column col-5 show_label">View Employee Package</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value="" v-model="checkedPermissions"></div>
											</div>    
											<div class="columns show_div3  grey_div">
												<div class="column col-5 show_label"> Submit Package</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value="" v-model="checkedPermissions"></div>
											</div>
											<div class="columns show_div3 ">
												<div class="column col-5 show_label">Add Earnings</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value="" v-model="checkedPermissions"></div>
											</div>
											<div class="columns show_div3  grey_div">
												<div class="column col-5 show_label">View Earnings</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value="" v-model="checkedPermissions"></div>
											</div>
											<div class="columns show_div3 ">
												<div class="column col-5 show_label">Delete Earnings</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value="" v-model="checkedPermissions"></div>
											</div>  
											<div class="columns show_div3  grey_div">
												<div class="column col-5 show_label"> View Deductions</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value="" v-model="checkedPermissions"></div>
											</div>
											<div class="columns show_div3 ">
												<div class="column col-5 show_label">Add Deductions</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value="" v-model="checkedPermissions"></div>
											</div>
											<div class="columns show_div3  grey_div">
												<div class="column col-5 show_label">Delete Deductions</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value="" v-model="checkedPermissions"></div>
											</div>            
										</div>
									</div>	
									<div class="accordion">
										<input type="checkbox" id="accordion-2" name="accordion-checkbox" hidden>
										<label class="accordion-header" for="accordion-2">
											<i class="icon icon-arrow-right mr-1"></i>
											<span class="employee_role_text"><b>Payroll</b></span>
										</label>
										<div class="accordion-body ac_body">
											<!-- Accordions content -->	
											<div class="columns show_div3  grey_div">
												<div class="column col-5 show_label permissions_text">Permissions</div>            
											</div>
											<div class="columns show_div3 ">
												<div class="column col-5 show_label">Run Payroll</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value="" v-model="checkedPermissions"></div>
											</div>
											<div class="columns show_div3  grey_div">
												<div class="column col-5 show_label">Upload Pay Register</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value="" v-model="checkedPermissions"></div>
											</div>
											<div class="columns show_div3 ">
												<div class="column col-5 show_label">View Payslip</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value="" v-model="checkedPermissions"></div>
											</div>
											<div class="columns show_div3  grey_div">
												<div class="column col-5 show_label">Download Payslip</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value="" v-model="checkedPermissions"></div>
											</div>	
											<div class="columns show_div3 ">
												<div class="column col-5 show_label">Print Payslip</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value="" v-model="checkedPermissions"></div>
											</div>				
										</div>
									</div>
									<div class="accordion">
										<input type="checkbox" id="accordion-3" name="accordion-checkbox" hidden>
										<label class="accordion-header" for="accordion-3">
											<i class="icon icon-arrow-right mr-1"></i>
											<span class="employee_role_text"><b>Approvals</b></span>
										</label>
										<div class="accordion-body ac_body">
											<!-- Accordions content -->				
										</div>
									</div>
									<div class="accordion">
										<input type="checkbox" id="accordion-4" name="accordion-checkbox" hidden>
										<label class="accordion-header" for="accordion-4">
											<i class="icon icon-arrow-right mr-1"></i>
											<span class="employee_role_text"><b>Tasks</b></span>
										</label>
										<div class="accordion-body ac_body">
											<!-- Accordions content -->					
										</div>
									</div>
									<div class="accordion">
										<input type="checkbox" id="accordion-5" name="accordion-checkbox" hidden>
										<label class="accordion-header" for="accordion-5">
											<i class="icon icon-arrow-right mr-1"></i>
											<span class="employee_role_text"><b>Settings</b></span>
										</label>
										<div class="accordion-body ac_body">
											<!-- Accordions content -->	
											<div class="columns show_div3  grey_div">
												<div class="column col-5 show_label permissions_text">Permissions</div>            
											</div>
											<div class="columns show_div3 ">
												<div class="column col-5 show_label">Create Package Template</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value="" v-model="checkedPermissions"></div>
											</div>
											<div class="columns show_div3  grey_div">
												<div class="column col-5 show_label">View Package Template</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value="" v-model="checkedPermissions"></div>
											</div>
											<div class="columns show_div3 ">
											<div class="column col-5 show_label"> Edit Package Template</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value="" v-model="checkedPermissions"></div>
											</div>
											<div class="columns show_div3  grey_div">
												<div class="column col-5 show_label">Delete Package Template</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value="" v-model="checkedPermissions"></div>
											</div>
											<div class="columns show_div3 ">
												<div class="column col-5 show_label">View Roles</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value="" v-model="checkedPermissions"></div>
											</div>
											<div class="columns show_div3  grey_div">
												<div class="column col-5 show_label"> Edit Role Permission</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value="" v-model="checkedPermissions"></div>
											</div>
											<div class="columns show_div3 ">
												<div class="column col-5 show_label">Create Role</div>
												<div class="column col-4 show_field"><input type="checkbox" name="" value="" v-model="checkedPermissions"></div>
											</div>         				
										</div>
									</div>
								</div>  
							</div>
								<div class="column col-4 show_field hidden-checkbox"><input type="checkbox" name="permissions[]" value=" " checked></div>
            </form>
						<div class="button_div3 columns column col12" v-if="display_add">
							<div class="column col6 cancel_group" v-on:click="closeModal"><img src="/images/icons/show_page_cancel.svg" alt="Cancel icon" class=""/><span class="icon_label">CANCEL</span></diV>
							<div class="column col6 right_align edit_group" v-on:click="addPermissions" ><img src="/images/icons/submit_blue_bg.svg" alt="Submit icon" class=""/><span class="icon_label">SUBMIT</span></div>
						</div>
						<div class="button_div3 columns column col12" v-if="display_edit">
							<div class="column col6 cancel_group" v-on:click="closeModal" ><img src="/images/icons/show_page_cancel.svg" alt="Cancel icon" class=""/><span class="icon_label">CANCEL</span></diV>
							<div class="column col6 right_align edit_group" v-on:click="editPermissions" ><img src="/images/icons/update.svg" alt="Submit icon" class=""/><span class="icon_label">UPDATE</span></div>
						</div>
          </div>
        </div>
       </div>
      </div>
    </span>
</template>
<script>
import axios from "axios";
import { mapGetters } from 'vuex'
export default {
	name:'Role', 
	props:['display_add', 'display_edit' ],
  data(){
    return {	
			role:[],
			checkedPermissions: [],
			roleError: false
      
    }  
  },
  methods: {    
    removeClass_role: function(event){this.roleError=false;},

		closeModal:function (event) {      
      this.display_edit=false;
      this.display_add=false;
      this.$emit('close-modal');
		},
		
		editPermissions(e){
      e.preventDefault();
      const axios = require("axios");
      var url = "/api/settings/change_role";
      let csrf = document.querySelector("meta[name='csrf-token']").getAttribute("content");
      var permission_form = document.getElementById("edit-permissions-form");      
			var data = new FormData(permission_form);
			console.log(data);		
      axios.post( url, data, { headers: {'Content-Type': 'application/json', 'x-csrf-token': csrf}})
      .then((response)=>{
        console.log(response)
				 });		
			
		},
		addPermissions(e){
      e.preventDefault();
      const axios = require("axios");
      var url = '/api/settings/new_role';
      let csrf = document.querySelector("meta[name='csrf-token']").getAttribute("content");
      var permission_form = document.getElementById("add-permissions-form");      
			var data = new FormData(permission_form);
			var role = data.get('role[name]'); 
			var permissions = data.get('permissions[]'); 			
			if(!role ){  this.roleError=true; }
			if(role && permissions && permissions !== " " ){			
      axios.post( url, data, { headers: {'Content-Type': 'application/json', 'x-csrf-token': csrf}})
      .then((response)=>{
        
         });}
		},
		
		 onChange(role) {
			 this.checkedPermissions=[]
      console.log(role.permissions.length)
      for (var i=0; i< role.permissions.length; i++){
        this.checkedPermissions.push(role.permissions[i].name)         
      }
  }    
	},
	computed: {    
    ...mapGetters([
      'user_roles'
    ])
	},
	
	mounted(){
		console.log(this.user_roles)
		const axios = require('axios');
    axios.get('/api/settings/get_role')
    .then((response) => {
      this.$store.commit('list_roles', response.data.roles)
      console.log(this.user_roles)
      
      
    });
	}
}

</script>
<style >

</style>